/*********************************************************************/
/*                                                                   */
/*  This Program Written by Paul Edwards.                            */
/*  Released to the Public Domain                                    */
/*                                                                   */
/*********************************************************************/
/*********************************************************************/
/*                                                                   */
/*  bin2hex - encode a binary file as hex                            */
/*                                                                   */
/*********************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAXCHAR 16

int main(int argc, char **argv)
{
    int c;
    FILE *inf;
    int x = 0;

    if (argc <= 1)
    {
        printf("usage: bin2hex <binary file>\n");
        return (EXIT_FAILURE);
    }
    inf = fopen(*(argv + 1), "rb");
    if (inf == NULL)
    {
        printf("failed to open %s for reading\n", *(argv + 1));
        return (EXIT_FAILURE);
    }
    while ((c = getc(inf)) != EOF)
    {
        if (x == 0)
        {
            printf("    \"");
        }
        printf("\\x%02X", c);
        x++;
        if (x == MAXCHAR)
        {
            printf("\"\n");
            x = 0;
        }
    }
    if (x != 0)
    {
        printf("\"\n");
    }
    return (0);
}
