/*********************************************************************/
/*                                                                   */
/*  This Program Written by Paul Edwards.                            */
/*  Released to the Public Domain                                    */
/*                                                                   */
/*********************************************************************/
/*********************************************************************/
/*                                                                   */
/*  copycon - copy from console                                      */
/*                                                                   */
/*********************************************************************/

#include <stdio.h>
#include <stdlib.h>

static char buf[300];

int main(int argc, char **argv)
{
    FILE *outf;

    if (argc <= 1)
    {
        printf("usage: copycon <output file>\n");
        printf("copies from stdin (console/keyboard) until you enter a '.'\n");
        return (EXIT_FAILURE);
    }
    outf = fopen(*(argv + 1), "w");
    if (outf == NULL)
    {
        printf("failed to open %s for writing\n", *(argv + 1));
        return (EXIT_FAILURE);
    }
    while (fgets(buf, sizeof buf, stdin) != NULL)
    {
        if (strcmp(buf, ".\n") == 0) break;
        fputs(buf, outf);
    }
    fclose(outf);
    return (0);
}
