/*********************************************************************/
/*                                                                   */
/*  This Program Written By Paul Edwards.                            */
/*  Released to the public domain.                                   */
/*                                                                   */
/*********************************************************************/
/*********************************************************************/
/*                                                                   */
/*  zsubstr - substr all records in a file                           */
/*                                                                   */
/*  This program takes the following parameters:                     */
/*  1) Name of input file                                            */
/*  2) Name of output file                                           */
/*  3) Starting column                                               */
/*  4) Ending column                                                 */
/*                                                                   */
/*********************************************************************/

#include <stddef.h>
#include <stdio.h>
#include <strinl.h>
#include <string.h>
#include <stdlib.h>

static char buf[37269U];

int main(int argc,char **argv)
{
    FILE *fp,*fq;
    int from, to;

    if (argc < 5)
    {
        printf("must specify input file, output file\n");
        printf("start column and end column\n");
        return (EXIT_FAILURE);
    }
    fp = fopen(*(argv+1),"r");
    if (fp == NULL)
    {
        printf("unable to open %s\n", *(argv + 1));
        return (EXIT_FAILURE);
    }
    fq = fopen(*(argv+2),"w");
    if (fq == NULL)
    {
        printf("unable to open %s\n", *(argv + 2));
        return (EXIT_FAILURE);
    }
    from = atoi(*(argv+3));
    to = atoi(*(argv+4));

    while (fgets(buf,sizeof(buf),fp) != NULL)
    {
        int len,x,y;

        strinl(buf);
        len = strlen(buf);
        y = to;
        if (y > len) y = len;
        x = from;
        if (x > y) x = y;
        fwrite(buf+x-1,y-x+1,1,fq);
        fputc('\n',fq);
    }
    return (0);
}
