#
#	NMH's Simple C Compiler, 2011,2012
#	C runtime module
#	Version using system LIBC's system call layer
#

#	FreeBSD voodoo magic

#	.section .note.ABI-tag,"a",@note
	.align	4
abitag: .long	8, 4, 1
#	.string	"FreeBSD"
	.long	802000
	.data
	.p2align 2

	.data
	.globl	Cenviron
	.globl	environ		# unused, but needed by LIBC
	.globl	__progname	# unused, but needed by LIBC
environ:
__progname:
Cenviron:
	.long	0

	.text
	.globl	_main
_main:	movl	8(%esp),%esi	# argv
	movl	4(%esp),%ecx	# argc
	movl	%ecx,%eax	# environ = &argv[argc+1]
	incl	%eax
	shll	$2,%eax
	addl	%esi,%eax
	movl	%eax,Cenviron
	pushl	%ecx
	pushl	%esi
	pushl	$2		# __argc
	call	C_init
	call	Cmain
	addl	$12,%esp
	pushl	%eax
	pushl	$1
x:	call	Cexit
	xorl	%ebx,%ebx
	divl	%ebx
	jmp	x

# internal switch(expr) routine
# %esi = switch table, %eax = expr

	.globl	switch
switch:	pushl	%esi
	movl	%edx,%esi
	movl	%eax,%ebx
	cld
	lodsl
	movl	%eax,%ecx
next:	lodsl
	movl	%eax,%edx
	lodsl
	cmpl	%edx,%ebx
	jnz	no
	popl	%esi
	jmp	*%eax
no:	loop	next
	lodsl
	popl	%esi
	jmp	*%eax

# int setjmp(jmp_buf env);

	.globl	Csetjmp
Csetjmp:
	movl	8(%esp),%edx
	movl	%esp,(%edx)
	addl	$4,(%edx)
	movl	%ebp,4(%edx)
	movl	(%esp),%eax
	movl	%eax,8(%edx)
	xorl	%eax,%eax
	ret

# void longjmp(jmp_buf env, int v);

	.globl	Clongjmp
Clongjmp:
	movl	8(%esp),%eax	# v
	orl	%eax,%eax
	jne	vok
	incl	%eax
vok:	movl	12(%esp),%edx	# env
	movl	(%edx),%esp
	movl	4(%edx),%ebp
	movl	8(%edx),%edx
	jmp	*%edx

# int _exit(int rc);

	.globl	C_exit
C_exit:	pushl	8(%esp)
	call	_exit
	addl	$4,%esp
	ret

# int sbrk(int size);

	.globl	Csbrk
Csbrk:	pushl	8(%esp)
#	call	sbrk
	addl	$4,%esp
	ret

# int _write(int fd, char *buf, int len);

	.globl	C_write
C_write:
	pushl	8(%esp)
	pushl	16(%esp)
	pushl	24(%esp)
	call	_write
	addl	$12,%esp
	ret

# int _read(int fd, char *buf, int len);

	.globl	C_read
C_read:	pushl	8(%esp)
	pushl	16(%esp)
	pushl	24(%esp)
	call	_read
	addl	$12,%esp
	ret

# malloc
	.globl	Cmalloc
Cmalloc:
	pushl	8(%esp)
	call	_malloc
	addl	$4,%esp
	ret

# realloc
	.globl	Crealloc
Crealloc:
	pushl	8(%esp)
	pushl	16(%esp)
	call	_realloc
	addl	$8,%esp
	ret

# calloc
	.globl	Ccalloc
Ccalloc:
	pushl	8(%esp)
	call	_calloc
	addl	$4,%esp
	ret

# free
	.globl	Cfree
Cfree:
	pushl	8(%esp)
	call	_free
	addl	$4,%esp
	ret

# int _lseek(int fd, int pos, int how);

	.globl	C_lseek
C_lseek:
	pushl	8(%esp)
	movl	16(%esp),%eax
	cdq
	pushl	%edx		# off_t, high word
	pushl	%eax		# off_t, low word
	pushl	28(%esp)
	call	_lseek
	addl	$16,%esp
	ret

# int _creat(char *path, int perm);

	.globl	C_creat
C_creat:
	pushl	8(%esp)
	pushl	16(%esp)
	call	_creat
	addl	$8,%esp
	ret

# int _open(char *path, int flags);

	.globl	C_open
C_open:	pushl	8(%esp)
	pushl	16(%esp)
	call	_open
	addl	$8,%esp
	ret

# int _close(int fd);

	.globl	C_close
C_close:
	pushl	8(%esp)
	call	_close
	addl	$4,%esp
	ret

# int _unlink(char *path);

	.globl	C_unlink
C_unlink:
	pushl	8(%esp)
	call	_unlink
	addl	$4,%esp
	ret

# int rename(char *old, char *new);

	.globl	Crename
Crename:
	pushl	8(%esp)
	pushl	16(%esp)
	call	_rename
	addl	$8,%esp
	ret

# int _system(char *cmd);

	.globl	C_system
C_system:
	pushl	8(%esp)
#	call	execve
	addl	$4,%esp
	ret

# int _time(void);

	.globl	C_time
C_time:	push	$0
#	call	time
	addl	$4,%esp
	ret

# int raise(int sig);

	.globl	Craise
Craise:
#	call	getpid
	push	8(%esp)
	push	%eax
#	call	kill
	addl	$8,%esp
	ret

# int signal(int sig, int (*fn)());

	.globl	Csignal
Csignal:
	pushl	8(%esp)
	pushl	16(%esp)
#	call	signal
	addl	$8,%esp
	ret
